<!--
/*
 *  Copyright 2012 by Texas Instruments Incorporated .
 *  
 */
-->

<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>Linux Utils Application Programming Interface (API): cmem.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<table width="100%">
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border="0" src="tilogo.gif" /></a></td>
  <td bgcolor="red"><img src="titagline.gif" /></td>
</tr>
</table>
<!-- Generated by Doxygen 1.7.2 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li id="searchli">
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath">
    <ul>
      <li><a class="el" href="dir_46b89352121e85f687ad94af5a42b013.html">packages</a>      </li>
      <li><a class="el" href="dir_dbdfbfe4e1be114d6b897afedfbff330.html">ti</a>      </li>
      <li><a class="el" href="dir_964ef0e4710265d31c86c3d996641bc2.html">sdo</a>      </li>
      <li><a class="el" href="dir_bc87c15b970aa649e4a4941daccc7a87.html">linuxutils</a>      </li>
      <li><a class="el" href="dir_d4af0b1248caa752cbdf2db1f39b1140.html">cmem</a>      </li>
      <li><a class="el" href="dir_31f7569a4f66b5c99cb80ea1cba815cc.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Defines</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<h1>cmem.h File Reference</h1>  </div>
</div>
<div class="contents">
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Describes the interface to the contiguous memory allocator. </p>
<p>The cmem user interface library wraps file system calls to an associated kernel module (cmemk.ko), which needs to be loaded in order for calls to this library to succeed.</p>
<p>The following is an example of installing the cmem kernel module:</p>
<div class="fragment"><pre class="fragment">/sbin/insmod cmemk.ko pools=4x30000,2x500000 phys_start=0x0 phys_end=0x3000000 </pre></div><ul>
<li>phys_start and phys_end must be specified in hexadecimal format</li>
<li>phys_start is "inclusive" and phys_end is "exclusive", i.e., phys_end should be "end address + 1".</li>
<li>pools must be specified using decimal format (for both number and size), since using hexadecimal format would visually clutter the specification due to the use of "x" as a token separator</li>
<li>it's possible to insmod cmemk.ko without specifying any memory blocks, in which case <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gad568ae7a470d1465164a26d304b6c9a0" title="Get the physical address of a contiguous buffer.">CMEM_getPhys()</a> and CMEM_cache*() APIs can still be utilized by an application.</li>
</ul>
<p>This particular command creates 2 pools. The first pool is created with 4 buffers of size 30000 bytes and the second pool is created with 2 buffers of size 500000 bytes. The CMEM pool buffers start at 0x0 and end at 0x2FFFFFF (max).</p>
<p>There is also support for a 2nd contiguous memory block to be specified, with all the same features supported for the 2nd block as with the 1st. This 2nd block is specified with *_1 parameters. The following example expands upon the first example above:</p>
<div class="fragment"><pre class="fragment">/sbin/insmod cmemk.ko pools=4x30000,2x500000 phys_start=0x0 phys_end=0x3000000
    pools_1=4x65536 phys_start_1=0x80000000 phys_end_1=0x80010000 </pre></div><p>This particular command, in addition to the pools explained above, creates 1 pool (with 4 buffers of size 64KB) in a 2nd memory block which starts at 0x80000000 and ends at 0x8000FFFF (specified as "end + 1" on the insmod command).</p>
<p>In order to access this 2nd memory block, new APIs have been added to CMEM which allow specification of the block ID.</p>
<p>There are two more configuration "switches" for the cmemk.ko kernel module, which can be specified on the 'insmod' (or 'modprobe') command lines: useHeapIfPoolUnavailable=[0|1] allowOverlap=[0|1]</p>
<p>'useHeapIfPoolUnavailable', when set to 1, will cause pool-based allocations to fallback to a heap-based allocation if no pool buffer of sufficient size is available (the CMEM heap is described below).</p>
<p>'allowOverlap', when set to 1, causes cmemk.ko to not fail when it detects that a CMEM memory block location conflicts with the Linux kernel memory, and instead an informational message is printed on the console. When set to 0, cmemk.ko insertion will fail when this condition is detected. The overlap detection is fairly crude, however, checking only that the end of the kernel's memory (assigned by way of the u-boot 'bootargs' parameter "mem=##M") is not above the beginning location of a CMEM memory block. For example, on most TI processor-based systems the kernel's memory starts at 0x80000000 and ends at (0x80000000 + #M), so a CMEM block starting at 0x1000 would be detected as overlapping since the beginning location of that block is not greater than the end location of the kernel's memory. To allow this situation, cmemk.ko should be inserted using "allowOverlap=1".</p>
<p>Pool buffers are aligned on a module-dependent boundary, and their sizes are rounded up to this same boundary. This applies to each buffer within a pool. The total space used by an individual pool will therefore be greater than (or equal to) the exact amount requested in the installation of the module.</p>
<p>The poolid used in the driver calls would be 0 for the first pool and 1 for the second pool.</p>
<p>Pool allocations can be requested explicitly by pool number, or more generally by just a size. For size-based allocations, the pool which best fits the requested size is automatically chosen. Some CMEM APIs (newer ones) accept a blockid as a parameter, in order to specify which of the multiple blocks to operate on. For 'legacy' APIs (ones that existed before the support for multiple blocks) where a blockid is still needed, block 0 is assumed.</p>
<p>There is also support for a general purpose heap. In addition to the 2 pools described above, a general purpose heap block is created from which allocations of any size can be requested. Internally, allocation sizes are rounded up to a module-dependent boundary and allocation addresses are aligned either to this same boundary or to the requested alignment (whichever is greater).</p>
<p>The size of the heap block is the amount of CMEM memory remaining after all pool allocations. If more heap space is needed than is available after pool allocations, you must reduce the amount of CMEM memory granted to the pools.</p>
<p>Buffer allocation is tracked at the file descriptor level by way of a 'registration' list. The initial allocator of a buffer (the process that calls <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a" title="Allocate memory of a specified size.">CMEM_alloc()</a>) is automatically added to the registration list, and further processes can become registered for the same buffer by way of the <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa0c312335d5fdc0457094e98a80a5795" title="Register shared usage of an already-allocated buffer.">CMEM_registerAlloc()</a> API (and unregister with the <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gadccb25f3cfcb630015f946fdfa481c8a" title="Unregister use of a buffer previously registered with CMEM_registerAlloc().">CMEM_unregister()</a> API). This registration list for each buffer allows for buffer ownership tracking and cleanup on a per-file-descriptor basis, so that when a process exits or dies without having explicitly freed/unregistered its buffers, they get automatically unregistered (and freed when no more registered file descriptors exist). Only when the last registered file descriptor frees a buffer (either explictily, or by auto-cleanup) does a buffer actually get freed back to the kernel module.</p>
<p>Since the CMEM interface library doesn't use the GT tracing facility, there is one configuration option available for the CMEM module to control whether the debug or release interface library is used for building the application. This config parameter is named 'debug' and is of type bool, and the default value is 'false'.</p>
<p>The following line is an example of enabling usage of the debug interface library: var cmem = xdc.useModule('ti.sdo.linuxutils.cmem.CMEM'); cmem.debug = true; This will enable "CMEM Debug" statements to be printed to stdout. </p>

<p><a href="cmem_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Parameters for <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a" title="Allocate memory of a specified size.">CMEM_alloc()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa246effe37bc6dafa7146c443c83e831" title="Allocate memory of a specified size from a specified memory block.">CMEM_alloc2()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga8def9ca65d0e48320525a12326686877" title="Allocate memory from a specified pool.">CMEM_allocPool()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga209562d2562a6a6f3ddcce162f835468" title="Allocate memory from a specified pool in a specified memory block.">CMEM_allocPool2()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae39f01bac7c437e9738090bef4aed158" title="Free a buffer previously allocated with CMEM_alloc()/CMEM_allocPool().">CMEM_free()</a>.  <a href="struct_c_m_e_m___alloc_params.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_c_m_e_m___block_attrs.html">CMEM_BlockAttrs</a></td></tr>
<tr><td colspan="2"><h2><a name="define-members"></a>
Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga742e77191f1efd05c9a4f3ffa247d7da">CMEM_VERSION</a>&#160;&#160;&#160;0x03000100U</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga187e4e9bf672a30c82a7b70b60542754">CMEM_WB</a>&#160;&#160;&#160;0x00010000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga84a13cfa52f98f56f979096a0b97f44c">CMEM_INV</a>&#160;&#160;&#160;0x00020000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae6df4f615573af4d9c8186384d180d84">CMEM_HEAP</a>&#160;&#160;&#160;0x00040000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga1131d153a198e8a45b480e2694c0aa56">CMEM_POOL</a>&#160;&#160;&#160;0x00000000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga894220a7ad3f4fe58272fa57e5716ff7">CMEM_CACHED</a>&#160;&#160;&#160;0x00080000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga50734833b9ef3a67e48d94d1e4cd1271">CMEM_NONCACHED</a>&#160;&#160;&#160;0x00000000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga9006bc536abeccec35c020f9bea41605">CMEM_PHYS</a>&#160;&#160;&#160;0x00100000</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gabd02db44a1dac13174ae356f4c4ce230">CMEM_IOCMAGIC</a>&#160;&#160;&#160;0x0000fe00</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gac1fd168739bd05307ec519d2d254f14a">CMEM_IOCALLOC</a>&#160;&#160;&#160;1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga17cdd5932da87a6ceebd53eeaccfcdf5">CMEM_IOCALLOCHEAP</a>&#160;&#160;&#160;2</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga3e5c2aa4938172852878743681f1deec">CMEM_IOCFREE</a>&#160;&#160;&#160;3</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga9bcdafb23157f060882296536f662620">CMEM_IOCGETPHYS</a>&#160;&#160;&#160;4</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga10a20aac6f8b10639d9f904004b7b3b7">CMEM_IOCGETSIZE</a>&#160;&#160;&#160;5</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa949ce903361352e2cc69a93b6a1bea1">CMEM_IOCGETPOOL</a>&#160;&#160;&#160;6</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga741576815e673fba2253028be1ed886d">CMEM_IOCCACHE</a>&#160;&#160;&#160;7</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga70664ef0aefedc53dc697baeec46a20d">CMEM_IOCGETVERSION</a>&#160;&#160;&#160;8</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga21a43bb3db137d462e3bff278c574da4">CMEM_IOCGETBLOCK</a>&#160;&#160;&#160;9</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga925be32918be15c2204b0cebe5921dec">CMEM_IOCREGUSER</a>&#160;&#160;&#160;10</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga386afee541b1c310a05855e34766459b">CMEM_IOCGETNUMBLOCKS</a>&#160;&#160;&#160;11</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga6588f2a6e6d151c881574296e1fa7c75">CMEM_IOCCACHEWBINV</a>&#160;&#160;&#160;CMEM_IOCCACHE | CMEM_WB | CMEM_INV</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8cb1794d3f8a650da956dbc827ffa04">CMEM_IOCCACHEWB</a>&#160;&#160;&#160;CMEM_IOCCACHE | CMEM_WB</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae3599cdcb42c124e1ba590eca5c79d56">CMEM_IOCCACHEINV</a>&#160;&#160;&#160;CMEM_IOCCACHE | CMEM_INV</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae46dd092114a9907c62d1af0d0a8282f">CMEM_IOCALLOCCACHED</a>&#160;&#160;&#160;CMEM_IOCALLOC | CMEM_CACHED</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga1f666e24302dd5f9d8489f1ab916aef3">CMEM_IOCALLOCHEAPCACHED</a>&#160;&#160;&#160;CMEM_IOCALLOCHEAP | CMEM_CACHED</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga41ee50820ad343b3b591e0ad38e5764d">CMEM_IOCFREEHEAP</a>&#160;&#160;&#160;CMEM_IOCFREE | CMEM_HEAP</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gad0d90d49e48e01a48490010a583f59f1">CMEM_IOCFREEPHYS</a>&#160;&#160;&#160;CMEM_IOCFREE | CMEM_PHYS</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gad1d6271519a725d94b29f2d096b6d898">CMEM_IOCFREEHEAPPHYS</a>&#160;&#160;&#160;CMEM_IOCFREE | CMEM_HEAP | CMEM_PHYS</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga60adf021b05573125be11ca3af825564">CMEM_IOCCMDMASK</a>&#160;&#160;&#160;0x000000ff</td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf772e1cf0334dca4e2cbb1acb1fa7a74">CMEM_AllocParams</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Parameters for <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a" title="Allocate memory of a specified size.">CMEM_alloc()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa246effe37bc6dafa7146c443c83e831" title="Allocate memory of a specified size from a specified memory block.">CMEM_alloc2()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga8def9ca65d0e48320525a12326686877" title="Allocate memory from a specified pool.">CMEM_allocPool()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga209562d2562a6a6f3ddcce162f835468" title="Allocate memory from a specified pool in a specified memory block.">CMEM_allocPool2()</a>, <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae39f01bac7c437e9738090bef4aed158" title="Free a buffer previously allocated with CMEM_alloc()/CMEM_allocPool().">CMEM_free()</a>.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf772e1cf0334dca4e2cbb1acb1fa7a74"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="struct_c_m_e_m___block_attrs.html">CMEM_BlockAttrs</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gab599820b841ce7113113c618fb0e8a85">CMEM_BlockAttrs</a></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga04a13119b1d6100b93b9d3476d42f915">CMEM_init</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the CMEM module. Must be called before other API calls.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga04a13119b1d6100b93b9d3476d42f915"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga61b4561b4f8e9c01a84b2ccd4d4c8531">CMEM_getPool</a> (size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the pool that best fits a given buffer size and has a buffer available.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga61b4561b4f8e9c01a84b2ccd4d4c8531"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga7923345b21ea4baf38f3b4a4c6a8ecf7">CMEM_getPool2</a> (int blockid, size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the pool in memory block blockid that best fits a given buffer size and has a buffer available.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga7923345b21ea4baf38f3b4a4c6a8ecf7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga8def9ca65d0e48320525a12326686877">CMEM_allocPool</a> (int poolid, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory from a specified pool.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga8def9ca65d0e48320525a12326686877"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga209562d2562a6a6f3ddcce162f835468">CMEM_allocPool2</a> (int blockid, int poolid, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory from a specified pool in a specified memory block.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga209562d2562a6a6f3ddcce162f835468"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a">CMEM_alloc</a> (size_t size, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory of a specified size.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa246effe37bc6dafa7146c443c83e831">CMEM_alloc2</a> (int blockid, size_t size, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate memory of a specified size from a specified memory block.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa246effe37bc6dafa7146c443c83e831"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa0c312335d5fdc0457094e98a80a5795">CMEM_registerAlloc</a> (unsigned long physp)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Register shared usage of an already-allocated buffer.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa0c312335d5fdc0457094e98a80a5795"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae39f01bac7c437e9738090bef4aed158">CMEM_free</a> (void *ptr, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free a buffer previously allocated with <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa8f06de969151e59379f7491b7c58b4a" title="Allocate memory of a specified size.">CMEM_alloc()</a>/CMEM_allocPool().  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae39f01bac7c437e9738090bef4aed158"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gadccb25f3cfcb630015f946fdfa481c8a">CMEM_unregister</a> (void *ptr, <a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a> *params)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Unregister use of a buffer previously registered with <a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaa0c312335d5fdc0457094e98a80a5795" title="Register shared usage of an already-allocated buffer.">CMEM_registerAlloc()</a>.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gadccb25f3cfcb630015f946fdfa481c8a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gad568ae7a470d1465164a26d304b6c9a0">CMEM_getPhys</a> (void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the physical address of a contiguous buffer.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gad568ae7a470d1465164a26d304b6c9a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaeef3fdc1bf833b34017c975a477dc278">CMEM_cacheWb</a> (void *ptr, size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Do a cache writeback of the block pointed to by <code>ptr/<code>size</code>.</code>  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaeef3fdc1bf833b34017c975a477dc278"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf1a3b3217f091db1d05aa4c1a2cf596a">CMEM_cacheInv</a> (void *ptr, size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Do a cache invalidate of the block pointed to by <code>ptr/<code>size</code>.</code>  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf1a3b3217f091db1d05aa4c1a2cf596a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga749afac6dc4077f4c7f947593497929e">CMEM_cacheWbInv</a> (void *ptr, size_t size)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Do a cache writeback/invalidate of the block pointed to by <code>ptr/<code>size</code>.</code>  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga749afac6dc4077f4c7f947593497929e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae4c4df4bae7464ffddd3f21b0815c10e">CMEM_getVersion</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve version from CMEM driver.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gae4c4df4bae7464ffddd3f21b0815c10e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaabdb4e2d51ff8c42e1aa8a05244555b6">CMEM_getBlock</a> (unsigned long *pphys_base, size_t *psize)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve memory block bounds from CMEM driver.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaabdb4e2d51ff8c42e1aa8a05244555b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf5bfc403676da91ecf44242d525afd8b">CMEM_getBlockAttrs</a> (int blockid, <a class="el" href="struct_c_m_e_m___block_attrs.html">CMEM_BlockAttrs</a> *pattrs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve extended memory block attributes from CMEM driver.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#gaf5bfc403676da91ecf44242d525afd8b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga5604844605a5e32dd4f242798b30dc09">CMEM_getNumBlocks</a> (int *pnblocks)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve number of blocks configured into CMEM driver.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga5604844605a5e32dd4f242798b30dc09"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga98363a0c4114e0227fbc1763203177b9">CMEM_exit</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Finalize the CMEM module.  <a href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga98363a0c4114e0227fbc1763203177b9"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="var-members"></a>
Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct_c_m_e_m___alloc_params.html">CMEM_AllocParams</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__cmem___c_m_e_m.html#ga02f27b513787b9581ebd67ff62827904">CMEM_DEFAULTPARAMS</a></td></tr>
</table>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1" /><small>
Copyright  2012, Texas Instruments Incorporated</small>
</body>
</html>
<!--
/*
 * @(#) linuxutils_3_23_00_01; 1, 0, 0,1; 5-30-2012 11:51:36; /db/atree/library/trees/linuxutils/linuxutils-l01/src/ xlibrary

 */
-->

